import pickle, os, sys
import pandas as pd

unit_tmp = sys.argv[1]

# if unit_tmp == "1":
#     directory = f"../result_sys_valid_tp_ecmwf/unit{unit_tmp}/"
#     df_all = pd.DataFrame()

#     for filename in os.listdir(directory):
#         f = os.path.join(directory, filename)
#         unit_max = pd.read_csv(f"{f}/unit{unit_tmp}_max.csv", header=None)#, index_col=0)
#         unit_max.columns = ["name", "unit", "file", "score"]
#         unit_max["cv"] = filename

#         if len(df_all) == 0:
#             df_all = unit_max
#         else:
#             for i in range(len(unit_max)):
#                 if df_all.iloc[i].name != unit_max.iloc[i].name:
#                     continue
#                 if df_all.iloc[i].score < unit_max.iloc[i].score:
#                     df_all.iloc[i] = unit_max.iloc[i]

#     df_all = df_all.set_index("name")
#     df_all.to_csv(f"../result_sys_valid_tp_ecmwf/unit1/unit{unit_tmp}_max_all.csv", header = False)


root_fldr = f"../result_sys_valid_tp_ecmwf/unit{unit_tmp}/cv_2012_2013"
tmp_lst = []
for filename in os.listdir(root_fldr):
    if "RegModel" in filename:
        file_tmp = filename.split("w560_")[-1]
        tmp_lst.append(file_tmp)

score_path = f"../result_sys_valid_tp_ecmwf/unit{unit_tmp}/cv_avg/"
if not os.path.exists(score_path):
    os.makedirs(score_path)

for feat_set in tmp_lst:
    d_2012 = pickle.load(open(f"../result_sys_valid_tp_ecmwf/unit{unit_tmp}/cv_2012_2013/rpss_dic/{feat_set}.pkl", "rb"))
    d_2014 = pickle.load(open(f"../result_sys_valid_tp_ecmwf/unit{unit_tmp}/cv_2014_2015/rpss_dic/{feat_set}.pkl", "rb"))
    d_2016 = pickle.load(open(f"../result_sys_valid_tp_ecmwf/unit{unit_tmp}/cv_2016_2017/rpss_dic/{feat_set}.pkl", "rb"))
    d_2018 = pickle.load(open(f"../result_sys_valid_tp_ecmwf/unit{unit_tmp}/cv_2018_2019/rpss_dic/{feat_set}.pkl", "rb"))

    df = pd.DataFrame([d_2012, d_2014, d_2016, d_2018])
    answer = dict(df.mean())

    f = open(score_path+feat_set+".pkl", "wb")
    pickle.dump(answer,f)       


df_all = pd.DataFrame()
for filename in os.listdir(score_path):
    f = os.path.join(score_path, filename)
    data = pickle.load(open(f, "rb"))
    file_name = filename.split(".")[0]
    df = pd.DataFrame.from_dict(data, orient='index')
    df.columns = [file_name]
    df_all = pd.concat([df_all, df], axis=1)

df_all.to_csv(f"../result_sys_valid_tp_ecmwf/unit{unit_tmp}/unit{unit_tmp}.csv")

df_all_argmax = df_all.idxmax(axis=1)
df_all_max = df_all.max(axis=1)
df_all_mm = pd.concat([df_all_argmax, df_all_max], axis=1)
df_all_mm.columns = ["feat_set", "score"]
address = [f"unit{unit_tmp}"]*len(df_all_max)
df_all_mm.insert(loc=0, column='unit_level', value=address)
df_all_mm.to_csv(f"../result_sys_valid_tp_ecmwf/unit{unit_tmp}/unit{unit_tmp}_max.csv", header = False)

print("!!!!!!!!!!! Finish !!!!!!!!!!!")